package com.bettersoftwarefaster.carserv.app;

import com.bettersoftwarefaster.carserv.infra.*;

/**
 * Represents the logical request to view another date in the service diary.
 *  The necessary information is provided as an instance of
 * DateChangedCommand.Arg.
 */
public abstract class DateChangedCommand extends AppActionCommand {
    public DateChangedCommand(String name, char mnemonic) {
        super(name, mnemonic);
    }

    public DateChangedCommand(String name) {
        super(name);
    }

    public final Command.ExecReturn doExecute(Object argAsObject)
    throws CommandException {
        return Command.ExecReturn.UNDOABLE;
    }

    public final Command.UndoReturn doUndo(Object argAsObject)
    throws CommandException {
        return Command.UndoReturn.REDOABLE;
    }

    public class Arg {
        public Arg(java.sql.Date previousDate) {
            this.previousDate = previousDate;
        }

        public java.sql.Date getPreviousDate() { return previousDate; }

        public java.sql.Date getNextDate() { return nextDate; }

        public void setNextDate(java.sql.Date date) { this.nextDate = date; }

        private java.sql.Date nextDate;
        private java.sql.Date previousDate;

        public String toString() {
            return "nextDate = " + getNextDate() + ", previousDate = " +
            getPreviousDate();
        }
    }
}
