package com.bettersoftwarefaster.carserv.app;

import java.util.*;
import javax.swing.*;
import com.bettersoftwarefaster.carserv.infra.*;
import com.bettersoftwarefaster.carserv.domain.*;

/**
 * Represents the logical request for an employee to log out.  The necessary
 * information is provided as an instance of LogoutCommand.Arg.
 */
public abstract class LogoutCommand extends AppActionCommand {
    public LogoutCommand(char logoutMnemonic) {
        super("Logout", logoutMnemonic);
    }

    public LogoutCommand() {
        super("Logout");
    }

    public Command.ExecReturn doExecute(Object argAsObject) {
        Arg arg = (Arg)argAsObject;
        if (arg.getCurrentUser() != null) {
            getApp().logout();
            return Command.ExecReturn.CLEAR;
        }
        return Command.ExecReturn.IGNORE;
    }

    public static class Arg {
        public Arg(Employee currentUser) {
            this.currentUser = currentUser;
        }

        public Employee getCurrentUser() { return currentUser; }

        private Employee currentUser;
    }
}
