package com.bettersoftwarefaster.carserv.datamgmt;

import java.util.*;
import java.sql.*;

/**
 * Provides transaction management and other database services; designed
 * to be subclassed.
 */
public abstract class DatabaseAdapter {
    protected void append(StringBuffer buf, boolean doAppend, String clause) {
        if (doAppend) {
            buf.append(clause);
        }
    }

    protected abstract Connection getConnection() throws DataMgmtException;

    protected abstract void beginTransaction() throws DataMgmtException;

    protected abstract void rollbackTransaction() throws DataMgmtException;

    protected abstract void commitTransaction() throws DataMgmtException;

    protected abstract PreparedStatement getPreparedStatement(String sql)
    throws DataMgmtException;

    /** any exceptions are disregarded */
    protected void closeStatement(Statement statement) {
        try {
            if (statement != null) {
                statement.close();
            }
        }
        catch (Exception ex) { }
    }
}
