package com.bettersoftwarefaster.carserv.datamgmt;

import java.util.*;

/**
 * Listener for database sessions.  Since a database session indicates that a
 * database connection has been established, some classes (specifically, the
 * database managers) need to know when the database session is available -
 * otherwise, they have no connection to do their work.
 * <p>An alternative design would have to make the Connection available as a
 * singleton, through some sort of javax.sql.Datasource lookup service.
 */
public interface DatabaseSessionListener {
    public void sessionAvailable(DatabaseSessionEvent p0);

    public void sessionUnavailable(DatabaseSessionEvent ev);

    public DatabaseSession getDatabaseSession();

    public boolean isSessionAvailable();
}
