package com.bettersoftwarefaster.carserv.datamgmt;

/**
 * Provide of database sessions.  Defines the semantic for notifying session
 * listeners that a database session is available.
 */
public interface DatabaseSessionProvider {
    public void addListener(DatabaseSessionListener client);

    public void removeListener(DatabaseSessionListener client);

    public void fireSessionAvailable(DatabaseSession session);

    public void fireSessionUnavailable(DatabaseSession session);

    public boolean isSessionAvailable();
}
