package com.bettersoftwarefaster.carserv.datamgmt;

import java.util.*;

/**
 * Immutable value object to represent Name information (first
 * name, last name).
 * @stereotype valueObject
 */
public class NameData extends ValueObject {
    public final static long serialVersionUID = 1;

    NameData(String lastName, String firstName) {
        this.lastName = lastName;
        this.firstName = firstName;
    }

    public String getLastName() { return lastName; }

    public String getFirstName() { return firstName; }

    public boolean equals(Object other) {
        if (!(other instanceof NameData))
            return false;
        NameData otherName = (NameData)other;
        return compareStrings(lastName, otherName.lastName) &&
        compareStrings(firstName, otherName.firstName);
    }

    public int hashCode() {
        return (lastName + ":" + firstName).hashCode();
    }

    public String toString() {
        return getClass().getName() + ": " +
        valueOf("lastName ", getLastName()) +
        valueOf("firstName", getFirstName());
    }

    private final String lastName;
    private final String firstName;
}
