package com.bettersoftwarefaster.carserv.datamgmt;

import java.util.*;
import java.sql.*;

/**
 * Creates ServiceData objects from a well-defined ResultSet.  Any user of
 * this class must provide a ResultSet with the following columns:
 * <li>car_license_plate:String <li>svc_booked_in:String <li>mdl_mileage:int
 * <li>svc_mileage:int <li>svc_picked_up:date <li>svc_lbr_adjustments:long
 * <li>svc_cim_adjustments:long
 */
public class ServiceDataHelper {
    ServiceData fetchServiceData(ResultSet resultSet) throws SQLException {
        return new ServiceData(resultSet.getString("car_license_plate"),
        resultSet.getDate("svc_booked_in"), resultSet.getInt("mdl_mileage"),
        resultSet.getInt("svc_mileage"), resultSet.getDate("svc_picked_up"),
        resultSet.getLong("svc_lbr_adjustments"), resultSet.getLong("svc_cim_adjustments"), null, null);
    }
}
