package com.bettersoftwarefaster.carserv.domain;

import java.util.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;

/**
 * Reference object that represents an Address.  <p>Implementation note: at
 * this point in time, we do not support changing address details, so the
 * class behaves like a value object and substantially delegates to its
 * underlying AddressData object.  If in the future we support changing
 * Address details, be careful to maintain reference object semantics.
 * @stereotype thing
 */
public class Address {
    Address(AddressData data) {
        reset(data);
    }

    void reset(AddressData data) {
        this.data = data;
    }

    public int getId() { return data.getId(); }

    public String getHouseNameNumber() { return data.getHouseNameNumber(); }

    public String getStreet() { return data.getStreet(); }

    public String getPostalCode() { return data.getPostalCode(); }

    public String getCity() { return data.getCity(); }

    public String getProvince() { return data.getProvince(); }

    public String toString() {
        return data.toString();
    }

    private AddressData data;
}
