package com.bettersoftwarefaster.carserv.domain;

import java.util.*;

/**
 * PersonRole for an owner of a car; currently only associated with customers,
 * though in the future, may wish to combine with Employee model, so that can
 * give discount to Employee's.
 * @stereotype role
 * @represents specification
 */
public interface CarOwner extends PersonRole {
    public List cars() throws DomainException;

    public int getOwnerId();

    public void refreshCars() throws DomainException;
}
