package com.bettersoftwarefaster.carserv.domain;

import java.util.*;

/** Adapter of Factory interface; designed to be subclassed. */
public abstract class FactoryAdapter implements Factory {
    FactoryAdapter() {
        this(new HashMap());
    }

    FactoryAdapter(Map map) {
        this.map = map;
        reset();
    }

    public void reset() {
        getMap().clear();
    }

    public Map getMap() {
        return this.map;
    }

    private final Map map;
}
