package com.bettersoftwarefaster.carserv.domain;

import java.util.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;

/**
 * Detail of a service, representing the work done by some Employee.
 * The Employee is expected to have the Mechanic role, and hence an hourlyRate.
 * <p>Implementation: thin wrapper around underlying data object;
 * instead of EmployeeData, uses Employee.
 * @stereotype mi-detail
 * @stereotype valueObject
 * @represents specification
 */
public class Labour {
    Labour(Employee mechanic, int tenthsHours, String notes) {
        this.mechanic = mechanic;
        this.tenthsHours = tenthsHours;
        this.notes = notes;
    }

    private int tenthsHours;
    private String notes;

    public Employee getMechanic() {
        return this.mechanic;
    }

    public int getTenthsHours() {
        return this.tenthsHours;
    }

    public String getNotes() {
        return this.notes;
    }

    /**
     * @supplierRole mechanic
     * @clientCardinality 0..*
     * @supplierCardinality 1
     */
    private Employee mechanic;
}
