package com.bettersoftwarefaster.carserv.domain;

import java.util.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;

/**
 * Represents the description of some part (a catalogue item) that is used in
 * performing a service; for example "windscreen wipers".
 * @stereotype description
 * @represents specification
 * @see ChargeableItem
 * @see PartFactory
 */
public class Part {
    Part(PartData data) {
        this.partNumber = data.getNumber();
        this.description = data.getDescription();
        this.cost = data.getCost();
        this.data = data;
    }

    public int getPartNumber() {
        return partNumber;
    }

    public String getDescription() {
        return description;
    }

    public long getCost() {
        return cost;
    }

    PartData getData() {
        return data;
    }

    public String toString() {
        return "" + getDescription();
    }

    private String description;
    private int partNumber;
    private long cost;
    private PartData data;
}
