package com.bettersoftwarefaster.carserv.domain;

import java.util.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;

/**
 * Subclass of Service, representing a regular service scheduled for some
 * car.  Has an indirect relationship to ModelRegularService, in that the
 * mileage defined will be that for some ModelRegularService of the Model
 * type for the Car.
 * @stereotype moment-interval
 * @see ModelRegularService
 */
public class RegularService extends Service {
    RegularService(ServiceData data) {
        super(data);
        this.serviceMileage = data.getServiceMileage();
    }

    public int getServiceMileage() {
        return this.serviceMileage;
    }

    private int serviceMileage;

    /**
     * @link dependency
     * @clientCardinality   0..*
     * @supplierCardinality 1
     * @clientRole by mileage
     */

	/*#ModelRegularService modelRegularService;*/
}
