package com.bettersoftwarefaster.carserv.domain;

import java.util.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;

/**
 * Functions to convert instances of datamgmt ServiceData into domain
 * Service.  Similar to the Factory classes that exist for the other domain
 * objects, however note that Service is not fully implemented as a reference
 * object, whereas the other factories do ensure that references are unique.
 * <p>In other words, if have an instance of Service, can obtain a reference
 * to its Car, and any service for that car will always resolve back to the
 * same Car instance.  However, ask that Car what its services are, and you
 * won't necessarily find your original Service in the list of services that
 * the Car returns.
 * @see Service
 */
public class ServiceHelper {
    public Service serviceFor(ServiceData data) {
        if (data.getServiceMileage() == 0) {
            return new AdhocService(data);
        }
        else {
            return new RegularService(data);
        }
    }
}
