package com.bettersoftwarefaster.carserv.domain;

import java.util.*;

/**
 * Helper class to manage the set of ModelRegularService's for a Model.
 * @stereotype description
 */
public class ServiceSchedule {
    ServiceSchedule() {
        modelRegularServices = new TreeMap();
    }

    java.util.List mileages() {
        return new LinkedList(modelRegularServices.keySet());
    }

    void put(int mileage, ModelRegularService modelRegularService) {
        modelRegularServices.put(new Integer(mileage), modelRegularService);
    }

    boolean isValidServiceMileage(int mileage) {
        return modelRegularServices.get(new Integer(mileage)) != null;
    }

    public List parts(int mileage) throws DomainException {
        if (!isValidServiceMileage(mileage)) {
            throw new DomainException("Invalid service mileage.");
        }
        ModelRegularService modelRegularService =
        (ModelRegularService)modelRegularServices.get(new Integer(mileage));
        return modelRegularService.parts();
    }

    /**
     * @link aggregation
     *   @associates <{com.bettersoftwarefaster.carserv.domain.ModelRegularService}>
     *   @clientQualifier mileage
     * @clientCardinality 1
     * @supplierCardinality 1..*
     * @constraint {set}
     */
    private Map modelRegularServices;
}
