package com.bettersoftwarefaster.carserv.infra;

import java.util.*;

/**
 * Interface for classes that need to know when a command (invocation) has
 * been executed/undone/redone.
 */
public interface CommandHistoryListener {
    public void undoneCommandInvocation(CommandHistoryEvent ev);

    public void redoneCommandInvocation(CommandHistoryEvent ev);

    public void executedCommandInvocation(CommandHistoryEvent ev);

    public void clearedHistory(CommandHistoryEvent ev);
}
