package com.bettersoftwarefaster.carserv.infra;

import java.util.*;

/**
 * Invocation of a command at a point in time.  Typically expect to delegate
 * to an instance of Command.  A CommandInvocation normally would be expected
 * to remember the argument that was passed to the Command.
 * @stereotype moment-interval
 * @see Command
 */
public interface CommandInvocation {
    public Command.ExecReturn execute() throws CommandException;

    public Command.UndoReturn undo() throws CommandException;
}
