package com.bettersoftwarefaster.carserv.infra;

import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import java.sql.Date;

/**
 * Enhanced version of text field:, with direct support for displaying dates.
 */
public class DateTextField extends JTextField {
    public DateTextField(int numberOfColumns) {
        super(numberOfColumns);
        calendar = Calendar.getInstance();
    }

    public void setDate(Calendar calendar) {
        setDate(calendar.getTime());
    }

    public void setDate(Date date) {
        setDate(date.getTime());
    }

    public void setDate(java.util.Date date) {
        setDate(date.getTime());
    }

    public void setDate(long time) {
        long secondsSinceMidnight = time % (24 * 60 * 60 * 1000);
        long timeAsOfMidnight = time - secondsSinceMidnight;
        calendar.setTime(new java.util.Date(timeAsOfMidnight));
        updateText();
    }

    protected Calendar getCalendar() {
        return calendar;
    }

    private void updateText() {
        DateFormat dateFormat = new SimpleDateFormat("dd-MMM-yyyy");
        setText(dateFormat.format(calendar.getTime()));
    }

    public java.util.Date getDate() {
        return calendar.getTime();
    }

    private Calendar calendar;
}
