package com.bettersoftwarefaster.carserv.infra;

import javax.swing.*;
import java.awt.*;

/**
 * Enhanced version of JPanel, with a GridBagLayout layout manager.  The
 * nested class Constraints is designed to make it easier to add components.
 */
public class GridBagPanel extends JPanel {
    public GridBagPanel() {
        super(new GridBagLayout());
    }

    public static class Constraints extends GridBagConstraints {
        public Constraints(int gridx, int gridy, int gridwidth, int gridheight,
        int anchor, int fill, int insetTop, int insetLeft, int insetBottom,
        int insetRight) {
            this(gridx, gridy, gridwidth, gridheight, 0.0, 0.0, anchor, fill,
            0, 0, insetTop, insetLeft, insetBottom, insetRight);
        }

        public Constraints(int gridx, int gridy, int gridwidth, int gridheight,
        double weightx, double weighty, int anchor, int fill, int ipadx,
        int ipady, int insetTop, int insetLeft, int insetBottom,
        int insetRight) {
            super(gridx, gridy, gridwidth, gridheight, weightx, weighty, anchor, fill,
            new Insets(insetTop, insetLeft, insetBottom, insetRight),
            ipadx, ipady);
        }
    }
}
