package com.bettersoftwarefaster.carserv.infra;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;

/**
 * Enhanced version of ComboBox, created with a DefaultComboBoxModel and a
 * mnemonic'd label.
 */
public class LabelledComboBox extends JComboBox {
    public LabelledComboBox(String labelString, char mnemonic) {
        super(new DefaultComboBoxModel());
        label = new JLabel(labelString);
        label.setDisplayedMnemonic(mnemonic);
        label.setLabelFor(this);
    }

    public void setEnabled(boolean enabled) {
        super.setEnabled(enabled);
        label.setEnabled(enabled);
    }

    private final JLabel label;

    public void clear() {
        getDefaultComboBoxModel().removeAllElements();
    }

    public DefaultComboBoxModel getDefaultComboBoxModel() {
        return (DefaultComboBoxModel)getModel();
    }

    public JLabel getLabel() { return label; }

    public JComboBox getComboBox() { return this; }
}
