package com.bettersoftwarefaster.carserv.infra;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;

/** Enhanced version of JTextField that also has a mnemonic'd label. */
public class LabelledTextField extends DateTextField {
    public LabelledTextField(String labelString, int numberOfColumns) {
        super(numberOfColumns);
        label = new JLabel(labelString);
        label.setLabelFor(this);
    }

    public LabelledTextField(String labelString, char mnemonic,
    int numberOfColumns) {
        this(labelString, numberOfColumns);
        label.setDisplayedMnemonic(mnemonic);
    }

    public void setEnabled(boolean enabled) {
        super.setEnabled(enabled);
        label.setEnabled(enabled);
    }

    private final JLabel label;

    public JLabel getLabel() { return label; }

    public JTextField getTextField() { return this; }
}
