package com.bettersoftwarefaster.carserv.infra;

import java.util.*;

/**
 * Implementation of a command that logs its argument as a string.  Must be
 * explicitly provided with a Logger to log to.
 * @stereotype description
 */
public class LoggerCommand extends CommandAdapter {
    LoggerCommand(Logger logger) {
        this.logger = logger;
    }

    public Command.ExecReturn execute(Object arg) {
        logger.log("" + arg);
        return Command.ExecReturn.UNDOABLE;
    }

    public Command.UndoReturn undo(Object arg) {
        logger.log("undo: " + arg);
        return Command.UndoReturn.REDOABLE;
    }

    public boolean isUndoable() {
        return true;
    }

    public Logger getLogger() {
        return logger;
    }

    public String toString() {
        return "LoggerCommand, logger = " + getLogger();
    }

    private final Logger logger;
}
