package com.bettersoftwarefaster.carserv.infra;

import java.util.*;
import java.awt.*;
import javax.swing.*;
import com.bettersoftwarefaster.carserv.app.*;

/**
 * Enhanced version of JTabbedPane, allows names to be associated with each
 * tab.  However, note <b>dDoes not</b> support remove semantics.
 */
public class MappedTabbedPane extends JTabbedPane {
    private Map tabTitleComponentMap = new HashMap();

    public void insertTab(String title, Icon icon, Component component,
    String tip, int index) {
        super.insertTab(title, icon, component, tip, index);
        tabTitleComponentMap.put(title, component);
    }

    public void view(String title) {
        Object componentAsObject = tabTitleComponentMap.get(title);
        if (componentAsObject != null) {
            this.setSelectedComponent((Component)componentAsObject);
        }
    }
}
