package com.bettersoftwarefaster.carserv.infra;

import javax.swing.*;

/**
 * Enhanced version of JButton, allows a mnemonic to be supplied.  The
 * mnemonic can be provided either directly, or, if the Swing Action
 * constructor is being used, then the MnemonicButton will look for a property
 * bound in as "mnemonic" (used by app.AppAction).
 * @see AppAction
 */
public class MnemonicButton extends JButton {
    public MnemonicButton(String text, char mnemonic) {
        super(text);
        setMnemonic(mnemonic);
    }

    public MnemonicButton(Action action, char mnemonic) {
        super(action);
        setMnemonic(mnemonic);
    }

    public MnemonicButton(Action action) {
        super(action);
        Object mnemonicAsObject = action.getValue("mnemonic");
        if (mnemonicAsObject != null) {
            setMnemonic(((Character)mnemonicAsObject).charValue());
        }
    }
}
