package com.bettersoftwarefaster.carserv.infra;

import javax.swing.*;
import com.bettersoftwarefaster.carserv.app.*;

/**
 * Enhanced version of JMenu, directly supporting mnemonics.  Mnemonic can be
 * provided through Action, if bound in as property "mnemonic".
 * @see MnemonicButton
 */
public class MnemonicMenu extends JMenu {
    public MnemonicMenu(String text, char mnemonic) {
        super(text);
        setMnemonic(mnemonic);
    }

    public JMenuItem add(Action action) {
        JMenuItem menuItem = super.add(action);
        Object mnemonicAsObject = action.getValue("mnemonic");
        if (mnemonicAsObject != null) {
            menuItem.setMnemonic(((Character)mnemonicAsObject).charValue());
        }
        return menuItem;
    }
}
