

package com.bettersoftwarefaster.carserv.infra;

import javax.swing.*;

/**
 * Enhanced version of JMenuItem, directly supporting mnemonics.  Mnemonic can
 * be provided through Action, if bound in as property "mnemonic".
 * <p>Typically MnemonicMenu.add() is used to create menu items, rather than
 * constructing them directly with this class.
 */
public class MnemonicMenuItem extends JMenuItem {
    public MnemonicMenuItem(String text, char mnemonic) {
        super(text);
        setMnemonic(mnemonic);
    }

    public MnemonicMenuItem(Action action, char mnemonic) {
        super(action);
        setMnemonic(mnemonic);
    }

    public MnemonicMenuItem(Action action) {
        super(action);
        Object mnemonicAsObject = action.getValue("mnemonic");
        if (mnemonicAsObject != null) {
            setMnemonic(((Character)mnemonicAsObject).charValue());
        }
    }
}
