package com.bettersoftwarefaster.carserv.infra;

import javax.swing.*;

/**
 * Enhanced version of JRadioButton, directly supporting mnemonics.  Mnemonic
 * can be provided through Action, if bound in as property "mnemonic".
 * @see MnemonicButton
 */
public class MnemonicRadioButton extends JRadioButton {
    public MnemonicRadioButton(String text, char mnemonic, boolean selected) {
        super(text, selected);
        setMnemonic(mnemonic);
    }

    public MnemonicRadioButton(String text, char mnemonic) {
        this(text, mnemonic, false);
    }

    public MnemonicRadioButton(Action action, char mnemonic,
    boolean selected) {
        super(action);
        setSelected(selected);
        setMnemonic(mnemonic);
    }

    public MnemonicRadioButton(Action action, char mnemonic) {
        this(action, mnemonic, false);
    }

    public MnemonicRadioButton(Action action, boolean selected) {
        super(action);
        setSelected(selected);
        Object mnemonicAsObject = action.getValue("mnemonic");
        if (mnemonicAsObject != null) {
            setMnemonic(((Character)mnemonicAsObject).charValue());
        }
    }

    public MnemonicRadioButton(Action action) {
        this(action, false);
    }
}
