package com.bettersoftwarefaster.carserv.infra;

import java.util.*;

/**
 * Concrete implementation of CommandInvocation.
 * @stereotype moment-interval
 */
public class SimpleCommandInvocation extends LeafCommandInvocation {
    public SimpleCommandInvocation(Command command, Object arg) {
        this.command = command;
        this.arg = arg;
    }

    public Command.ExecReturn execute() throws CommandException {
        return command.execute(arg);
    }

    /** Command will throw exception if not undoable. */
    public Command.UndoReturn undo() throws CommandException {
        return command.undo(arg);
    }

    public Command getCommand() {
        return command;
    }

    public Object getArg() {
        return arg;
    }

    public String toString() {
        return "CommandInvocation: command=<" + getCommand() + "> arg=<" +
        getArg() + ">";
    }

    /**
     * @clientCardinality 0..*
     * @supplierCardinality 1
     */
    private final Command command;
    private final Object arg;
}
