package com.bettersoftwarefaster.carserv.ui;

import com.bettersoftwarefaster.carserv.infra.*;
import com.bettersoftwarefaster.carserv.domain.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/** Adjustments for labour or for parts of a service. */
public class AdjustmentsPanel extends GridBagPanel {
    AdjustmentsPanel(char adjustmentsMnemonic) {
        subTotalLTF = new LabelledTextField("Sub total:", 8);
        subTotalLTF.setEditable(false);
        subTotalLTF.setHorizontalAlignment(JTextField.RIGHT);
        adjustmentsLTF = new LabelledTextField("Adjustments:",
        adjustmentsMnemonic, 8);
        adjustmentsLTF.setHorizontalAlignment(JTextField.RIGHT);
        totalLTF = new LabelledTextField("Total:", 8);
        totalLTF.setEditable(false);
        totalLTF.setHorizontalAlignment(JTextField.RIGHT);
        add(subTotalLTF.getLabel(),
        new GridBagPanel.Constraints(0, 0, 1, 1, 13, 0, 5, 5, 5, 0));
        add(subTotalLTF,
        new GridBagPanel.Constraints(1, 0, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        5, 5, 5, 0));
        add(adjustmentsLTF.getLabel(),
        new GridBagPanel.Constraints(0, 1, 1, 1, 13, 0, 0, 5, 5, 0));
        add(adjustmentsLTF,
        new GridBagPanel.Constraints(1, 1, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        0, 5, 5, 0));
        add(totalLTF.getLabel(),
        new GridBagPanel.Constraints(0, 2, 1, 1, 13, 0, 0, 5, 5, 0));
        add(totalLTF,
        new GridBagPanel.Constraints(1, 2, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        0, 5, 5, 0));
    }

    public long getSubTotal() {
        return subTotal;
    }

    public void setSubTotal(long subTotal) {
        this.subTotal = subTotal;
        updateFields();
    }

    public long getAdjustments() {
        return adjustments;
    }

    public void setAdjustments(long adjustments) {
        this.adjustments = adjustments;
        updateFields();
    }

    public long getTotal() {
        return getSubTotal() - getAdjustments();
    }

    private void updateFields() {
        subTotalLTF.setText("" + getSubTotal() / 10000.0);
        adjustmentsLTF.setText("" + getAdjustments() / 10000.0);
        totalLTF.setText("" + getTotal() / 10000.0);
    }

    public void setEnabled(boolean enabled) {
        subTotalLTF.setEnabled(enabled);
        adjustmentsLTF.setEnabled(enabled);
        totalLTF.setEnabled(enabled);
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField subTotalLTF;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField adjustmentsLTF;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField totalLTF;
    private long subTotal;
    private long adjustments;
}
