package com.bettersoftwarefaster.carserv.ui;

import com.bettersoftwarefaster.carserv.domain.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import com.bettersoftwarefaster.carserv.infra.GridBagPanel;

/** Shows whether a user is logged on or not. */
public class CurrentUserPanel extends GridBagPanel implements SignOnListener {
    CurrentUserPanel() {
        currentUserLabel = new JLabel();
        add(currentUserLabel,
        new GridBagPanel.Constraints(1, 0, 2, 1, 1.0, 0.0, 13, 0, 0, 0,
        5, 5, 5, 5));
    }

    public void userSignedOn(SignOnEvent ev) {
        Employee currentUser = ev.getCurrentUser();
        currentUserLabel.setText(currentUser.getFirstName() + " " +
        currentUser.getLastName());
    }

    public void userLoggedOut(SignOnEvent ev) {
        currentUserLabel.setText("No user logged in.");
    }

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final JLabel currentUserLabel;
}
