package com.bettersoftwarefaster.carserv.ui;

import com.bettersoftwarefaster.carserv.infra.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;

/** Date text field, can be incremented/decremented daily/monthly. */
public class MutableDateTextField extends DateTextField {
    public MutableDateTextField() {
        super(8);
        setEditable(false);
        setDate(new java.util.Date());
    }

    public void incrementDay() {
        Calendar calendar = getCalendar();
        calendar.add(Calendar.DATE, +1);
        setDate(calendar);
    }

    public void decrementDay() {
        Calendar calendar = getCalendar();
        calendar.add(Calendar.DATE, -1);
        setDate(calendar);
    }

    public void incrementMonth() {
        Calendar calendar = getCalendar();
        calendar.add(Calendar.MONTH, +1);
        setDate(calendar);
    }

    public void decrementMonth() {
        Calendar calendar = getCalendar();
        calendar.add(Calendar.MONTH, -1);
        setDate(calendar);
    }

    public void serviceSelectionChanged(ServiceSelectionEvent ev) {
        setDate(ev.getService().getBookedIn());
    }
}
