package com.bettersoftwarefaster.carserv.ui;

import com.bettersoftwarefaster.carserv.infra.*;
import com.bettersoftwarefaster.carserv.app.*;
import com.bettersoftwarefaster.carserv.domain.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/** Shows the header info for a service (not labour, parts or adjustments). */
public class ServiceHeaderPanel extends GridBagPanel implements
ServiceSelectionListener {
    ServiceHeaderPanel() {
        bookedInLTF = new LabelledTextField("Booked in:", 8);
        bookedInLTF.setEditable(false);
        actualMileageLTF = new LabelledTextField("Actual mileage:", 7);
        actualMileageLTF.setEditable(false);
        pickedUpLTF = new LabelledTextField("Picked up:", 8);
        pickedUpLTF.setEditable(false);
        typeLTF = new LabelledTextField("Type:", 8);
        typeLTF.setEditable(false);
        serviceMileageLTF = new LabelledTextField("Service mileage:", 7);
        serviceMileageLTF.setEditable(false);
        add(bookedInLTF.getLabel(),
        new GridBagPanel.Constraints(0, 0, 1, 1, 13, 0, 0, 0, 5, 0));
        add(bookedInLTF,
        new GridBagPanel.Constraints(1, 0, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        0, 5, 5, 0));
        add(actualMileageLTF.getLabel(),
        new GridBagPanel.Constraints(3, 0, 1, 1, 13, 0, 0, 10, 5, 0));
        add(actualMileageLTF,
        new GridBagPanel.Constraints(4, 0, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        0, 5, 5, 0));
        add(typeLTF.getLabel(),
        new GridBagPanel.Constraints(0, 1, 1, 1, 13, 0, 0, 0, 5, 0));
        add(typeLTF,
        new GridBagPanel.Constraints(1, 1, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        0, 5, 5, 0));
        add(serviceMileageLTF.getLabel(),
        new GridBagPanel.Constraints(3, 1, 1, 1, 13, 0, 0, 10, 5, 0));
        add(serviceMileageLTF,
        new GridBagPanel.Constraints(4, 1, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        0, 5, 5, 0));
        add(pickedUpLTF.getLabel(),
        new GridBagPanel.Constraints(0, 2, 1, 1, 13, 0, 0, 0, 0, 0));
        add(pickedUpLTF,
        new GridBagPanel.Constraints(1, 2, 2, 1, 1.0, 0.0, 17, 2, 0, 0,
        0, 5, 0, 0));
    }

    public void serviceSelectionChanged(ServiceSelectionEvent ev) {
        this.service = ev.getService();
        bookedInLTF.setDate(service.getBookedIn());
        actualMileageLTF.setText("" + service.getActualMileage());
        if (service instanceof RegularService) {
            typeLTF.setText("Regular");
            serviceMileageLTF.setText("" +
            ((RegularService)service).getServiceMileage());
            serviceMileageLTF.setEnabled(true);
        }
        else {
            typeLTF.setText("Adhoc");
            serviceMileageLTF.setText("n/a");
            serviceMileageLTF.setEnabled(false);
        }
        java.sql.Date pickedUp = service.getPickedUp();
        if (pickedUp != null) {
            pickedUpLTF.setDate(pickedUp);
            pickedUpLTF.setEnabled(true);
        }
        else {
            pickedUpLTF.setText("n/a");
            pickedUpLTF.setEnabled(false);
        }
    }

    public Service getService() {
        return service;
    }

    private Service service;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField bookedInLTF;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField actualMileageLTF;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField pickedUpLTF;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField typeLTF;

    /**
     * @clientCardinality 1
     * @supplierCardinality 1
     * @link aggregationByValue
     */
    private final LabelledTextField serviceMileageLTF;
}
