package com.bettersoftwarefaster.carserv.ui;

import com.bettersoftwarefaster.carserv.infra.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * Aggregates (sub-)totals for parts & labour.  Also shows the
 * (non-implemented) pick-up button.
 */
public class TotalsPanel extends JPanel implements TotalChangedListener {
    TotalsPanel(char pickUpMnemonic) {
        super(new FlowLayout(FlowLayout.RIGHT));
        totalLTF = new LabelledTextField("Total:", 10);
        totalLTF.setHorizontalAlignment(JTextField.RIGHT);
        add(totalLTF.getLabel());
        add(totalLTF);
        add(new MnemonicButton("Pick up", pickUpMnemonic));
        totalsSourceMap = new HashMap();
    }

    public void totalChanged(TotalEvent ev) {
        totalsSourceMap.put(ev.getSource(), new Long(ev.getTotal()));
        long total = 0;
        for (Iterator iter = totalsSourceMap.values().iterator();
        iter.hasNext(); ) {
            Long subTotal = ((Long)iter.next());
            total += subTotal.longValue();
        }
        totalLTF.setText("" + total / 10000.0);
    }

    private final LabelledTextField totalLTF;
    private final Map totalsSourceMap;
}
