/* Generated by Together */

package com.bettersoftwarefaster.carserv.webui;

import com.bettersoftwarefaster.carserv.app.*;
import com.bettersoftwarefaster.carserv.domain.*;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.text.*;

/**
 * @servletName diaryTab
 * @webURLPattern /diaryTab
 */
public class DiaryTabServlet extends WebUIAdapterServlet {
    public String getServletInfo() {
        return "diaryTab";
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        PrintWriter out = response.getWriter();

        out.println("<pre>");
        out.println("<p>");
        processAndRenderDate(request, response);
        out.println("<hr>");
        renderServices(request, response);
        out.println("</pre>");
    }

    private void processAndRenderDate(HttpServletRequest request,
    HttpServletResponse response) throws IOException, ServletException {

        PrintWriter out = response.getWriter();
        String action = request.getParameter("action");

        if ("day_back".equals(action)) {
            getCalendar(request).add(Calendar.DATE, -1);
        }
        if ("day_forward".equals(action)) {
            getCalendar(request).add(Calendar.DATE, +1);
        }
        if ("month_back".equals(action)) {
            getCalendar(request).add(Calendar.MONTH, -1);
        }
        if ("month_forward".equals(action)) {
            getCalendar(request).add(Calendar.MONTH, +1);
        }

        out.println(
        table(1, 160,
        tr("left",
		td("left", 20, a(response.encodeURL("app"),
        "tab=diaryTab&action=day_back", "&lt;")) +
		td("left", 20, a(response.encodeURL("app"),
        "tab=diaryTab&action=day_forward", "&gt;")) +
		td("left", 20, a(response.encodeURL("app"),
        "tab=diaryTab&action=month_back", "&lt;&lt;")) +
		td("left", 20, a(response.encodeURL("app"),
        "tab=diaryTab&action=month_forward", "&gt;&gt;")) +
        td("left", 120, dateFormat.format(getCalendar(request).getTime())))));
    }

    private void renderServices(HttpServletRequest request,
    HttpServletResponse response) throws IOException, ServletException {

        PrintWriter out = response.getWriter();
        CarServApp carServApp = getApp(request);

        try {
            List serviceList = carServApp.listServices(
            new java.sql.Date(getCalendar(request).getTime().getTime()));
            StringBuffer rowBuffer = new StringBuffer();

            for (Iterator iter = serviceList.iterator(); iter.hasNext(); ) {
                Service service = (Service)iter.next();

                rowBuffer.append(
                tr("left",
                td("left", 80, service.getLicensePlate()) +
                td("left", 120, dateFormat.format(service.getBookedIn())) +
                td("left", 80, "" + service.getActualMileage())));
            }

            out.println(
            table(2, 280,
            tr("left",
            th("left", 80, "License Plate") +
            th("left", 120, "Booked in") +
            th("left", 80, "Act. Mileage")) +
            rowBuffer.toString()));

        }
        catch (AppException ex) {
            out.println("Unable to list services for that date.");
            log(ex.toString());
        }

    }

    private Calendar getCalendar(HttpServletRequest request) {
        Calendar calendar = (Calendar)getSession(request).getAttribute("calendar");
        if (calendar == null) {
            calendar = Calendar.getInstance();
            getSession(request).setAttribute("calendar", calendar);
        }
        return calendar;
    }

    private DateFormat dateFormat = new SimpleDateFormat("dd-MMM-yyyy");
}
