/* Generated by Together */

package com.bettersoftwarefaster.carserv.webui;

import com.bettersoftwarefaster.carserv.app.*;
import com.bettersoftwarefaster.carserv.infra.*;
import java.awt.event.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * @servletName signOn
 * @webURLPattern /signOn
 */
public class SignOnServlet extends WebUIAdapterServlet {
    public String getServletInfo() {
        return "signOn";
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

        PrintWriter out = response.getWriter();
        out.println("<pre>");
        CarServApp carServApp = getApp(request);

        String action = request.getParameter("action");

        if (carServApp.isLoggedIn()) {
            if ("LoggingOut".equals(action)) {
                logout(request, response);
            }
            else {
                renderSignedOn(request, response);
            }
        }
        else {
            if ("SigningOn".equals(action)) {
                signOn(request, response);
            }
            else {
                renderSignOnForm(request, response);
            }
        }

        out.println("</pre>");
    }

    public void renderSignOnForm(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

        PrintWriter out = response.getWriter();

        out.println(
        form("POST", response.encodeURL("app"), "submit",
        table(0, 279,
        rowFormInputField(71, "First name:", 208, "FirstName") +
        rowFormInputField(71, "Last name:", 208, "LastName") +
        hiddenInputField("action", "SigningOn"))));
    }

    public void renderSignedOn(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

        PrintWriter out = response.getWriter();
        CarServApp carServApp = getApp(request);

        out.println(
        "Signed on as: " + carServApp.getCurrentUser().getFirstName() +
        " " + carServApp.getCurrentUser().getLastName());
        out.println(a(response.encodeURL("app"),
        "action=LoggingOut", "Log out."));
    }

    private void signOn(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

        PrintWriter out = response.getWriter();
        final String lastName = request.getParameter("LastName");
        final String firstName = request.getParameter("FirstName");
        final CarServApp carServApp = getApp(request);

        SignOnCommand signOnCommand = new SignOnCommand() {
            public Object getArg(ActionEvent ev) {
                return new SignOnCommand.Arg(lastName, firstName);
            }
        };

        class SignOnCommandCompletionListener implements
        CommandCompletionListener {
            private CommandException ex =
            new CommandException("not completed.");

            public void commandCompleted(Command c, CommandException ex) {
                this.ex = ex;
            }

            CommandException getCommandException() { return ex; }
        }

        SignOnCommandCompletionListener signOnCommandCompletionListener =
        new SignOnCommandCompletionListener();
        signOnCommand.addCommandCompletionListener(signOnCommandCompletionListener);
        signOnCommand.executeSelf();
        try {
            signOnCommand.getThread().join(); // wait for async to complete.
        }
        catch (Exception ex) { }
        if (signOnCommandCompletionListener.getCommandException() == null) {
            renderSignedOn(request, response);
        }
        else {
            out.println("Failed to sign on.<p>");
            renderSignOnForm(request, response);
        }
    }

    private void logout(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

        final PrintWriter out = response.getWriter();
        final CarServApp carServApp = getApp(request);

        LogoutCommand logoutCommand = new LogoutCommand() {
            public Object getArg(ActionEvent ev) {
                return new LogoutCommand.Arg(carServApp.getCurrentUser());
            }
            public void postExecute(Object arg) {
                // session.invalidate(); - not necessary, CarServApp manages our state
            }
            public void executeFailed(CommandException ex) {
                // session.invalidate(); - not necessary, CarServApp manages our state
            }
        };

        logoutCommand.executeSelf();
        renderSignOnForm(request, response);
    }
}
