package test.com.bettersoftwarefaster.carserv;

import junit.framework.*;
import junitx.framework.*;
import java.util.*;
import java.awt.Color;
import com.bettersoftwarefaster.carserv.datamgmt.*;

public class TestData {


	private static TestDataMaker testDataMaker = new TestDataMaker();

	//////////////////////////////////////////////////////

	public static EmployeeData lancePercival() throws TestAccessException {
		return testDataMaker.makeEmployeeData(1, "Percival", "Lance", 0);
	}
	public static EmployeeData charlesHawtrey() throws TestAccessException {
		return testDataMaker.makeEmployeeData(2, "Hawtrey", "Charles", 330000);
	}
	public static EmployeeData hattieJacques() throws TestAccessException {
		return testDataMaker.makeEmployeeData(3, "Jacques", "Hattie", 400000);
	}
	public static EmployeeData sidneyJames() throws TestAccessException {
		return testDataMaker.makeEmployeeData(4, "James", "Sidney", 520000);
	}

	//////////////////////////////////////////////////////

	public static AddressData smithsAddress() throws TestAccessException {
		return testDataMaker.makeAddressData(1,"23", "Allerton Way",
					"L18 5ZZ", "Liverpool", "Merseyside");
	}

	//////////////////////////////////////////////////////

	public static CustomerData wilburSmith() throws TestAccessException {
		return testDataMaker.makeCustomerData(1, "Smith", "Wilbur",
			smithsAddress() );
	}
	public static CustomerData margeSmith() throws TestAccessException {
		return testDataMaker.makeCustomerData(2, "Smith", "Marge",
			smithsAddress() );
	}
	public static CustomerData frederickForsyth() throws TestAccessException {
		return testDataMaker.makeCustomerData(3, "Forsyth", "Frederick",
				testDataMaker.makeAddressData(3, "45", "Moss Pits Lane",
					"L17 3AA", "Liverpool", "Merseyside") );
	}
	public static CustomerData ireneMurdoch() throws TestAccessException {
		return testDataMaker.makeCustomerData(4, "Murdoch", "Irene",
				testDataMaker.makeAddressData(4, "87", "Sandy Beach Close",
					"L23 9TT", "Southport", "Lancashire") );
	}
	public static CustomerData nigellaLawson() throws TestAccessException {
		return testDataMaker.makeCustomerData(5, "Lawson", "Nigella",
				testDataMaker.makeAddressData(5, "The Laurels", "Woolyback Road",
					"L39 0PP", "Burscough", "Lancashire") );
	}

	//////////////////////////////////////////////////////

	public static CarData wilbursLegacy() throws TestAccessException {
		return testDataMaker.makeCarData("X 123 ABC", Color.black,
				"Legacy", "Subaru", TestData.wilburSmith().getId() );
	}

	public static CarData fredsImpreza() throws TestAccessException {
		return testDataMaker.makeCarData("T 321 KLM", Color.green,
					"Impreza", "Subaru", frederickForsyth().getId() );
	}
	public static CarData fredsFocus() throws TestAccessException {
		return testDataMaker.makeCarData("V 654 NPQ", Color.yellow,
					"Focus", "Ford", frederickForsyth().getId() );
	}

	//////////////////////////////////////////////////////

	public static PartData oil() throws TestAccessException {
		return testDataMaker.makePartData(1, "5 Litres oil", 109900);
	}
	public static PartData sparkPlug() throws TestAccessException {
		return testDataMaker.makePartData(2, "Spark plug", 39900 );
	}
	public static PartData brakePads() throws TestAccessException {
		return testDataMaker.makePartData(3, "Brake pads", 970000 );
	}
	public static PartData windscreenWipers() throws TestAccessException {
		return testDataMaker.makePartData(4, "Windscreen wipers", 47500 );
	}
	public static PartData regularTyre() throws TestAccessException {
		return testDataMaker.makePartData(5, "Regular tyre", 302500 );
	}
	public static PartData lowProfileTyre() throws TestAccessException {
		return testDataMaker.makePartData(6, "Low profile tyre", 799900 );
	}
	public static PartData windscreen() throws TestAccessException {
		return testDataMaker.makePartData(7, "Windscreen", 1250000 );
	}
	public static PartData tailgateLamp() throws TestAccessException {
		return testDataMaker.makePartData(8, "Tailgate lamp", 238000 );
	}

	//////////////////////////////////////////////////////

	public static PartData[] justOil() throws TestAccessException {
		return new PartData[] { oil() };
	}
	public static PartData[] oilAndSparkPlug() throws TestAccessException {
		return new PartData[] { oil(), sparkPlug() };
	}
	public static PartData[] oilSparkPlugAndBrakePads() throws TestAccessException {
		return new PartData[] { oil(), sparkPlug(), brakePads() };
	}

}


