package test.com.bettersoftwarefaster.carserv;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;
import java.awt.Color;

public class TestDataMaker extends PrivateTestCase {
	TestDataMaker() {
		super("dummy");
	}
	public EmployeeData makeEmployeeData(int id, String lastName,
		String firstName, long mechanicLabourRate)
				throws TestAccessException {
		return(EmployeeData)newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.EmployeeData",
			"_int_java.lang.String_java.lang.String_long",
			new Object[] { new Integer(id), lastName, firstName,
				new Long(mechanicLabourRate) } );
	}

	public CustomerData makeCustomerData(int id, String lastName, String firstName, AddressData address)
			throws TestAccessException {
		return(CustomerData) newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.CustomerData",
			"_int_java.lang.String_java.lang.String_com.bettersoftwarefaster.carserv.datamgmt.AddressData",
			new Object[] { new Integer(id), lastName, firstName, address } );
	}

	public AddressData makeAddressData(int id, String houseNameNumber, String street,
		String postalCode, String city, String province)
			throws TestAccessException {
		return(AddressData) newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.AddressData",
			"_int_java.lang.String_java.lang.String_java.lang.String_java.lang.String_java.lang.String",
			new Object[] { new Integer(id), houseNameNumber, street, postalCode, city, province } );
	}

	public CarData makeCarData(String licensePlate, Color colour,
		String model, String manufacturer, int ownerId)
				throws TestAccessException {
		return(CarData)newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.CarData",
			"_java.lang.String_java.awt.Color_java.lang.String_java.lang.String_int",
			new Object[] { licensePlate, colour, model, manufacturer, new Integer(ownerId) } );
	}

	public RegularServiceData makeRegularServiceData(String model, int mileage,
			List parts)
				throws TestAccessException {
		return(RegularServiceData) newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.RegularServiceData",
			"_java.lang.String_int_java.util.List",
			new Object[] { model, new Integer(mileage), parts } );
	}

	public ServiceData makeServiceData(String licensePlate, Date bookedIn,
			int serviceMileage,	int actualMileage, Date pickedUp,
			long labourAdjustments, long chargeableItemAdjustments,
			Map labour, Map chargeableItems )
		throws TestAccessException {
		Object serviceDataObject = null;
		return(ServiceData)newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.ServiceData",
			"_java.lang.String_java.sql.Date_int_int_java.sql.Date_long_long_java.util.Map_java.util.Map",
			new Object[] { licensePlate, bookedIn,
				new Integer(serviceMileage), new Integer(actualMileage),
				pickedUp,
				new Long(labourAdjustments), new Long(chargeableItemAdjustments),
				labour, chargeableItems } );
	}

	public PartData makePartData(int number, String description, long cost)
				throws TestAccessException {
		return(PartData)newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.PartData",
			"_int_java.lang.String_long",
			new Object[] { new Integer(number), description, new Long(cost) } );
	}

	public ServiceData.Labour makeServiceDataLabour(EmployeeData mechanic, int tenthsOfHours, String notes)
				throws TestAccessException {
		return(ServiceData.Labour)newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.ServiceData$Labour",
			"_com.bettersoftwarefaster.carserv.datamgmt.EmployeeData_int_java.lang.String",
			new Object[] { mechanic, new Integer(tenthsOfHours), notes } );
	}

	public ServiceData.ChargeableItems makeServiceDataChargeableItems(PartData part, int numberOfItems)
				throws TestAccessException {
		return(ServiceData.ChargeableItems)newInstanceWithKey(
			"com.bettersoftwarefaster.carserv.datamgmt.ServiceData$ChargeableItems",
			"_com.bettersoftwarefaster.carserv.datamgmt.PartData_int",
			new Object[] { part, new Integer(numberOfItems) } );
	}

	public Map labourMapByMechanic(ServiceData.Labour[] labour) {
		Map map = new HashMap();
		for (int i=0; i<labour.length; i++) {
			map.put(labour[i].getMechanic(), labour[i]);
		}
		return map;
	}

	public Map chargeableItemsMapByPart(ServiceData.ChargeableItems[] chargeableItems) {
		Map map = new HashMap();
		for (int i=0; i<chargeableItems.length; i++) {
			map.put(chargeableItems[i].getPart(), chargeableItems[i]);
		}
		return map;
	}
}


