package test.com.bettersoftwarefaster.carserv;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import java.sql.*;
import java.text.*;
import java.awt.Color;

public class TestHelper extends TestDataMaker {

	public TestHelper(String dbType) {
   		this.dateFormat = new SimpleDateFormat("y-M-d");

// hack for Cloudscape 3.0, remote, GMT
// not needed for Cloudscape 3.6, remote, British Summer Time;
// hmmm... don't know if was change from 3.0 to 3.6, or from GMT to BST.
//		if (dbType.equals("remote")) {
//			this.dateFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
//		}
	}

	public void removeService(Connection connection, String licensePlate, java.sql.Date bookedIn) {

		try {
			StringBuffer buf = new StringBuffer();
			buf.append("\n DELETE FROM svc_service");
			buf.append("\n WHERE  car_license_plate = ?");
			buf.append("\n AND    svc_booked_in = ?");
			PreparedStatement deleteServicePS = connection.prepareStatement(buf.toString());

			buf = new StringBuffer();
			buf.append("\n DELETE FROM lbr_labour");
			buf.append("\n WHERE  car_license_plate = ?");
			buf.append("\n AND    svc_booked_in = ?");
			PreparedStatement deleteServiceLabourPS = connection.prepareStatement(buf.toString());

			buf = new StringBuffer();
			buf.append("\n DELETE FROM cim_chargeable_item");
			buf.append("\n WHERE  car_license_plate = ?");
			buf.append("\n AND    svc_booked_in = ?");
			PreparedStatement deleteServiceChargeableItemsPS = connection.prepareStatement(buf.toString());

			deleteServiceLabourPS.clearParameters();
			deleteServiceLabourPS.setString(1, licensePlate);
			deleteServiceLabourPS.setDate(2, bookedIn);
			deleteServiceLabourPS.executeUpdate();

			deleteServiceChargeableItemsPS.clearParameters();
			deleteServiceChargeableItemsPS.setString(1, licensePlate);
			deleteServiceChargeableItemsPS.setDate(2, bookedIn);
			deleteServiceChargeableItemsPS.executeUpdate();

			deleteServicePS.clearParameters();
			deleteServicePS.setString(1, licensePlate);
			deleteServicePS.setDate(2, bookedIn);
			deleteServicePS.executeUpdate();
		} catch(Exception ex) {
			System.out.println("Problem removing service, car = " + licensePlate + ", bookedIn = " + bookedIn);
			ex.printStackTrace();
		}
	}

	public void assertContainSame(String msg, List expected, List actual) {
		assertTrue("Some " + msg + " expected are missing, \n" +
				"actual = \n" + actual + "\nexpected = \n" + expected,
				actual.containsAll(expected));
		assertTrue("Some " + msg + " not expected were returned, \n" +
				"actual = \n" + actual + "\nexpected = \n" + expected,
			expected.containsAll(actual));
	}

	public java.sql.Date makeDate(int yyyy, int mm, int dd) {

		try {
			java.sql.Date date = new java.sql.Date(
				this.dateFormat.parse(""+yyyy+"-"+mm+"-"+dd).getTime());
			return date;
		} catch(Exception ex) {
			return null;
		}
	}

	private final DateFormat dateFormat;
}


