package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.domain.*;


public abstract class CarTestCase extends CustomerTestCase {

	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public CarTestCase(String aName) {
		super(aName);
	}

	/**
	 * prepares the environment and ressource to run the tests
	 * contained in this test case.
	 */
	protected void setUp() throws DomainException, TestAccessException {
		super.setUp();

		List customers = getCustomerFactory().listCustomers("Lawson", "Nigella", null);
		nigella = (Customer)customers.get(0);

		customers = getCustomerFactory().listCustomers("Smith", "Wilbur", null);
		wilbur = (Customer)customers.get(0);

		nigellasCar = (Car)nigella.cars().get(0);
	}

	/**
	 * resets the environment and releases the ressources used by the tests
	 * contained in this test case.
	 */
	protected void tearDown() throws DomainException, TestAccessException {
		nigellasCar = null;
		nigella = null;
		wilbur = null;
		super.tearDown();
	}

	protected CustomerFactory getCustomerFactory() {
		return DomainSingletonManager.getInstance().getCustomerFactory();
	}
	protected CarFactory getCarFactory() {
		return DomainSingletonManager.getInstance().getCarFactory();
	}

	/**
	 * @supplierRole nigella
	 */
	protected Customer nigella;
	/**
	 * @supplierRole wilbur
	 */
	protected Customer wilbur;
	protected Car nigellasCar;

}
