package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import java.text.*;
import com.bettersoftwarefaster.carserv.infra.*;
import com.bettersoftwarefaster.carserv.domain.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;
import test.com.bettersoftwarefaster.carserv.*;

public abstract class DomainTestCase extends PrivateTestCase {

	public DomainTestCase(String aName) {
		super(aName);
		this.testHelper = new TestHelper(DatabaseSession.DB_TYPE);
	}

	protected DomainSingletonManager getSingletonManager() {
		return domainSingletonManager;
	}

	protected DomainSessionManager getSessionManager() {
		return getSingletonManager().getDomainSessionManager();
	}

	protected void setUp() throws DomainException, TestAccessException  {
		domainSingletonManager = new DomainSingletonManager(new SingletonRegister());
	}

	protected void tearDown() throws DomainException, TestAccessException  {
		domainSingletonManager = null;
	}

	protected final TestHelper testHelper;

	private DomainSingletonManager domainSingletonManager;
}
