package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.domain.*;


public abstract class ModelTestCase extends CustomerTestCase {

	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public ModelTestCase(String aName) {
		super(aName);
	}

	/**
	 * prepares the environment and ressource to run the tests
	 * contained in this test case.
	 */
	protected void setUp() throws DomainException, TestAccessException {
		super.setUp();
		modelFactory = getSingletonManager().getModelFactory();
		customerFactory = getSingletonManager().getCustomerFactory();
		fred = customerFactory.getCustomer(3);
		fredsCars = fred.cars();
	}

	/**
	 * resets the environment and releases the ressources used by the tests
	 * contained in this test case.
	 */
	protected void tearDown() throws DomainException, TestAccessException {
		fredsCars = null;
		fred = null;
		customerFactory = null;
		modelFactory = null;
		super.tearDown();
	}

	/**
	 * @supplierRole fred 
	 */
	protected Customer fred;
	protected List fredsCars;
	protected ModelFactory modelFactory;
	protected CustomerFactory customerFactory;
}

