package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import java.sql.*;
import com.bettersoftwarefaster.carserv.domain.*;


/** @stereotype test */
public class TestAdhocService extends TestService {

	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public TestAdhocService(String aName) {
		super(aName);
	}

	protected Service serviceUnderTest() {
		return nigellasAdhocService;
	}

	public void testGetBookedIn() throws DomainException {
		nigellasAdhocService.bookInCar(22555);
		assertEquals(testHelper.makeDate(2001, 06, 04), nigellasAdhocService.getBookedIn());
	}

	protected void setUp() throws DomainException, TestAccessException {
		super.setUp();
		nigellasAdhocService =
			nigellasCar.scheduleAdhocService(testHelper.makeDate(2001, 06, 04));
	}

	protected void tearDown() throws DomainException, TestAccessException {
//        Connection connection = getCarServApp().getCurrentDatabaseSession().getConnection();
		Connection connection = (Connection)invoke(getSessionManager().getCurrentDatabaseSession(), "getConnection", new Object[] { } );
		testHelper.removeService(
			connection,
			nigellasCar.getLicensePlate(), testHelper.makeDate(2001, 06, 04));
		super.tearDown();
	}



	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */
	static public Test suite() {
		return new TestSuite(TestAdhocService.class);
	}

	/**
	 * @supplierRole nigellasAdhocService 
	 */
	private AdhocService nigellasAdhocService;
}


