package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.domain.*;


/** @stereotype test */
public class TestCarFactory extends CarTestCase {

	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public TestCarFactory(String aName) {
		super(aName);
	}

	public void testGetCarByLicensePlateNotInMap() throws DomainException {
		Car car = getCarFactory().getCar( "X 123 ABC" );
		assertEquals("X 123 ABC", car.getLicensePlate());
	}

	public void testGetCarByLicensePlateInMap() throws DomainException {
		Car car = getCarFactory().getCar( nigellasCar.getLicensePlate() );
		assertEquals(nigellasCar, car);
	}

	public void testGetCarByLicensePlateDataInMap() throws DomainException {
		Car car = getCarFactory().getCar( nigellasCar.getLicensePlate(), nigellasCar.getData() );
		assertEquals(nigellasCar, car);
	}

	public void testGetCarByLicensePlateCarOwnerDataInMap() throws DomainException {
		Car car = getCarFactory().getCar( nigellasCar.getLicensePlate(), nigella, nigellasCar.getData() );
		assertEquals(nigellasCar, car);
	}

	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */
	static public Test suite() {
		return new TestSuite(TestCarFactory.class);
	}
}
