package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.domain.*;


/**
 * @stereotype test 
 */
public class TestCustomer extends CustomerTestCase {
	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public TestCustomer(String aName) {
		super(aName);
	}

	public void testGetCustomerId() throws DomainException {
		Customer wilbur = customerFactory.getCustomer(1);

		assertEquals(1, wilbur.getCustomerId());
	}

	public void testCars() throws DomainException {
		Customer fred = customerFactory.getCustomer(3);

		List fredsCars = fred.cars();

		assertEquals(2, fredsCars.size());
	}

	public void testUpdate() throws DomainException {
		Customer fred = customerFactory.getCustomer(3);

		fred.update("Forsyth", "Fred");

		fred = customerFactory.getCustomer(3);

		assertEquals("Fred", fred.getFirstName());
	}

	/**
	 * resets the environment and releases the ressources used by the tests
	 * contained in this test case.
	 */
	protected void tearDown() throws DomainException, TestAccessException  {

		// reset the database
		Customer fred = customerFactory.getCustomer(3);
		fred.update("Forsyth", "Frederick");

		super.tearDown();
	}

	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */

	static public Test suite() {
		return new TestSuite(TestCustomer.class);
	}
}

