package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junit.swingui.*;



/** @stereotype test package */


public class TestDomainPackage	implements junitx.framework.TestPackage
{
	/**
	 * main method for running the JUnitX UI.
	 * @param   anArgArray    an array of options
	 */

	static public void main(String[] anArgArray) {
		junit.swingui.TestRunner.run(TestDomainPackage.class);
	}

	/**
	 * creates a suite of test cases.
	 * @return  a <code>TestSuite</code>
	 */

	static public Test suite() {
		TestSuite suite = new TestSuite("domain package test suite");
		TestSuite singletonSessionSuite = new TestSuite("singleton & session manager");
		TestSuite customerSuite = new TestSuite("model");
		TestSuite modelSuite = new TestSuite("model");
		TestSuite carSuite = new TestSuite("car");
		TestSuite serviceSuite = new TestSuite("service");

		singletonSessionSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestInstantiateDomainSingletonManager.class);
		singletonSessionSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestDomainSingletonManager.class);
		singletonSessionSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestDomainSessionManager.class);
		customerSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestCustomerFactory.class);
		customerSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestCustomer.class);
		modelSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestModelFactory.class);
		modelSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestModel.class);
		carSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestCarFactory.class);
		carSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestCar.class);
		serviceSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestRegularService.class);
		serviceSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.domain.TestAdhocService.class);

		suite.addTest(singletonSessionSuite);
		suite.addTest(customerSuite);
		suite.addTest(modelSuite);
		suite.addTest(carSuite);
		suite.addTest(serviceSuite);

		return suite;
	}
}

