package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.domain.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;
import test.com.bettersoftwarefaster.carserv.*;

/** @stereotype test */
public class TestDomainSingletonManager extends DomainTestCase {

	public TestDomainSingletonManager(String aName) {
		super(aName);
	}

	public void testFactoriesSetupAsSingletons() throws TestAccessException {
		assertNotNull("customer factory", getSingletonManager().getCustomerFactory());
		assertNotNull("car factory", getSingletonManager().getCarFactory());
		assertNotNull("model factory", getSingletonManager().getModelFactory());
		assertNotNull("part factory", getSingletonManager().getPartFactory());
		assertNotNull("employee factory", getSingletonManager().getEmployeeFactory());
	}

	public void testHelpersSetupAsSingletons() throws TestAccessException {
		assertNotNull(getSingletonManager().getServiceHelper());
	}

	public void testDataManagersSetupAsSingletons() throws TestAccessException {
		assertNotNull("cust dm", getSingletonManager().getCustDM());
		assertNotNull("car dm", getSingletonManager().getCarDM());
		assertNotNull("service dm", getSingletonManager().getServiceDM());
	}

	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */

	static public Test suite() {
		return new TestSuite(TestDomainSingletonManager.class);
	}
}


