package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.domain.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;


/** @stereotype test */
public class TestModel extends ModelTestCase {
	/**
	 * constructor.
	 * @param    aName     a test name
	 */

	public TestModel(String aName) {
		super(aName);
	}

	public void testGetName() throws DomainException {
		Model focus = modelFactory.getModel("Focus");
		assertEquals("Focus", focus.getName() );
	}

	public void testIsValidServiceMileageWithValidMileage() throws DomainException {
		Model focus = modelFactory.getModel("Focus");
		assertTrue(focus.isValidServiceMileage(9000) );
	}

	public void testIsValidServiceMileageWithInvalidMileage() throws DomainException {
		Model focus = modelFactory.getModel("Focus");
		assertTrue(!focus.isValidServiceMileage(9001) );
	}

	public void testPartsServiceWithOnePart() throws DomainException {
		Model focus = modelFactory.getModel("Focus");
		List parts = focus.parts(9000);
		assertEquals(1, parts.size() );
	}

	public void testPartsServiceWithTwoParts() throws DomainException {
		Model focus = modelFactory.getModel("Focus");
		List parts = focus.parts(27000);
		assertEquals(2, parts.size() );
	}

	protected void setUp() throws DomainException, TestAccessException {
		super.setUp();
		// prime model factory
		for (Iterator iter = fredsCars.iterator(); iter.hasNext(); ) {
			CarData data = ((Car)iter.next()).getData();
			Model model = modelFactory.getModel( data.getModel(), data );
		}
	}

	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */

	static public Test suite() {
		return new TestSuite(TestModel.class);
	}
}
