package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import com.bettersoftwarefaster.carserv.domain.*;
import com.bettersoftwarefaster.carserv.datamgmt.*;


/**
 * @stereotype test 
 */
public class TestModelFactory extends ModelTestCase {

	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public TestModelFactory(String aName) {
		super(aName);
	}

	/**
	 * tests the method com.bettersoftwarefaster.carserv.domain.ModelFactory.getModel().
	 */

	public void testGetModelByName() throws DomainException {

		// prime model factory
		for (Iterator iter = fredsCars.iterator(); iter.hasNext(); ) {
			CarData data = ((Car)iter.next()).getData();
			Model model = modelFactory.getModel( data.getModel(), data );
		}

		assertTrue(modelFactory.getModel("Focus") != null);
	}
	/**
	 * tests the method com.bettersoftwarefaster.carserv.domain.ModelFactory.getModel().
	 */

	public void testGetModelByData() throws DomainException {
		// prime model factory
		for (Iterator iter = fredsCars.iterator(); iter.hasNext(); ) {
			CarData data = ((Car)iter.next()).getData();
			Model model = modelFactory.getModel( data.getModel(), data );
		}

		CarData fredsFirstCarData = ( (Car)fredsCars.get(0) ).getData();
		assertNotNull( modelFactory.getModel(fredsFirstCarData.getModel(), fredsFirstCarData) );
	}

	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */
	static public Test suite() {
		return new TestSuite(TestModelFactory.class);
	}
}
