package test.com.bettersoftwarefaster.carserv.domain;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import java.sql.*;
import com.bettersoftwarefaster.carserv.domain.*;


/** @stereotype test */
public class TestRegularService extends TestService {

	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public TestRegularService(String aName) {
		super(aName);
	}

	protected Service serviceUnderTest() {
		return nigellasRegularService;
	}

	public void testGetBookedIn() throws DomainException {
		nigellasRegularService.bookInCar(22555);
		assertEquals(testHelper.makeDate(2002, 02, 01), nigellasRegularService.getBookedIn());
	}

	public void testGetServiceMileage() {
		assertEquals(22500, nigellasRegularService.getServiceMileage());
	}

	protected void setUp() throws DomainException, TestAccessException {
		super.setUp();
		nigellasRegularService =
			nigellasCar.scheduleRegularService(testHelper.makeDate(2002, 02, 01), 22500);
	}

	protected void tearDown() throws DomainException, TestAccessException {
//        Connection connection = getCarServApp().getCurrentDatabaseSession().getConnection();
		Connection connection = (Connection)invoke(getSessionManager().getCurrentDatabaseSession(), "getConnection", new Object[] { } );


		testHelper.removeService(
			connection,
			nigellasCar.getLicensePlate(), testHelper.makeDate(2002, 02, 01));
		super.tearDown();
	}

	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */
	static public Test suite() {
		return new TestSuite(TestRegularService.class);
	}

	/**
	 * @supplierRole nigellasRegularService 
	 */
	private RegularService nigellasRegularService;
}


