package test.com.bettersoftwarefaster.carserv.infra;

import java.util.*;
import com.bettersoftwarefaster.carserv.infra.*;

public class NotUndoableActionCommand extends ActionCommand {
	NotUndoableActionCommand(ActionHistory actionHistory) {
		super(actionHistory);
	}

	public Command.ExecReturn execute(Object arg) {
		actionHistory.push(arg);
		return Command.ExecReturn.NOT_UNDOABLE;
	}

	/**
	 * No need to throw an exception, will be done for us since we have
	 * declared that we are not undoable
     * For this reason our return code matters not, either.
	 */
	public Command.UndoReturn undo(Object arg) throws CommandException {
		throw new CommandException("Not undoable.");
	}

	public String toString() {
		return "NotUndoableActionCommand";
	}
}


