package test.com.bettersoftwarefaster.carserv.infra;

import junit.framework.*;
import junit.swingui.*;


/** @stereotype test package */

public class TestInfraPackage implements junitx.framework.TestPackage
{
	/**
	 * main method for running the JUnitX UI.
	 * @param   anArgArray    an array of options
	 */

	static public void main(String[] anArgArray) {
		junit.swingui.TestRunner.run(TestInfraPackage.class);
	}

	/**
	 * creates a suite of test cases.
	 * @return  a <code>TestSuite</code>
	 */

	static public Test suite() {
		TestSuite suite = new TestSuite("infra package test suite");

		TestSuite commandSuite = new TestSuite("command");
		TestSuite commandInvocationSuite = new TestSuite("command invocation");
		TestSuite commandManagerSuite = new TestSuite("command manager");

		commandSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestPrintCommand.class);
		commandSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestNullCommand.class);
		commandSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestTraceCommand.class);
		commandSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestCompositeCommand.class);
		commandSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestNotUndoableCommand.class);
		commandInvocationSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestNotUndoableCompositeCommand.class);
		commandInvocationSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestTraceCommandInvocation.class);
		commandInvocationSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestCommandInvocation.class);
		commandInvocationSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestNotUndoableCommandInvocation.class);
		commandInvocationSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestCompositeCommandInvocation.class);
		commandInvocationSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestNotUndoableCompositeCommandInvocation.class);
		commandManagerSuite.addTestSuite(test.com.bettersoftwarefaster.carserv.infra.TestCommandManager.class);

		suite.addTest(commandSuite);
		suite.addTest(commandInvocationSuite);
		suite.addTest(commandManagerSuite);


		return suite;
	}
}

