package test.com.bettersoftwarefaster.carserv.infra;

import junit.framework.*;
import junitx.framework.*;
//import junit.util.*;
import java.util.*;
import java.io.*;
import com.bettersoftwarefaster.carserv.infra.*;


/** @stereotype test */
public class TestPrintCommand extends TestCase {

	/**
	 * constructor.
	 * @param    aName     a test name
	 */
	public TestPrintCommand(String aName) {
		super(aName);
		systemOut = System.out;  // hold onto for later
	}

	public void testExecute() throws CommandException {
		OutputStream testOut = new ByteArrayOutputStream();
		System.setOut(new PrintStream(testOut));

		command.execute("This is a test");
		assertTrue(testOut.toString().startsWith("This is a test") );

		System.setOut(systemOut);
	}

	public void testToString() {
		assertEquals("PrintCommand", command.toString());
	}

	protected void setUp() {
		command = new PrintCommand();
	}

	protected void tearDown() {
		command = null;
		System.setOut(systemOut); // in case any problems during test runs
	}

	/**
	 * returns a <code>TestSuite</code> instance which contains this
	 * class as only test.
	 * @return  a <code>TestSuite</code>
	 */
	static public Test suite() {
		return new TestSuite(TestPrintCommand.class);
	}

	private Command command;
	private OutputStream testOut;

	private final PrintStream systemOut;
}
