package com.togethersoft.modules.bettersoftwarefaster.rwisupport;

import com.togethersoft.openapi.ide.*;
import com.togethersoft.openapi.ide.message.*;

import com.togethersoft.openapi.rwi.*;
import java.util.*;

/**
 * Collect all elements in the model, using a delegation design.  Then,
 * just print out the number of elements.
 */
public class DemoDelegatorModule implements IdeScript {

    public DemoDelegatorModule() {
		rwiVisitorSupport = new RwiVisitorSupport("DemoDelegator",
						            new DemoDelegatorVisitor(rwiElements),
						            new DemoDelegatorFilter() );
    }

	public void run(IdeContext ideContext) {
        rwiVisitorSupport.getMessagePage().printMessage("Started.");

    	if (!rwiVisitorSupport.isActiveProject())
        	return;

		rwiVisitorSupport.getRwiVisitorDispatcher().visitAndDispatch();

		rwiVisitorSupport.getMessagePage().printMessage("Number of elements: " + getCollectedRwiElements().size() );
        rwiVisitorSupport.getMessagePage().setVisible(true);
        rwiVisitorSupport.getMessagePage().printMessage("Finished.");
	}

	public List getCollectedRwiElements() {
		return Collections.unmodifiableList(rwiElements);
	}
    /**
    * @supplierRole collectedRwiElements
    * @link aggregation
    * @supplierCardinality 1
    */
	private List rwiElements = new LinkedList();

    /**
     * @link aggregationByValue
     * @supplierCardinality 1 
     */
    private RwiVisitorSupport rwiVisitorSupport;
}
