package com.togethersoft.modules.bettersoftwarefaster.rwisupport;

import com.togethersoft.openapi.ide.*;
import com.togethersoft.openapi.ide.message.*;

import com.togethersoft.openapi.rwi.*;
import java.util.*;

/**
 * Visitor that simply collects all elements in the RWI model, so that they can be counted up. 
 */
class DemoDelegatorVisitor implements RwiVisitor {

	DemoDelegatorVisitor(List rwiElements) {
        this.rwiElements = rwiElements;
    }

	public Object visitPackage(RwiPackage rwiPackage) {
		rwiElements.add(rwiPackage);
		return null;
	}

	public Object visitDiagram(RwiDiagram rwiDiagram) {
		rwiElements.add(rwiDiagram);
		return null;
	}

	public Object visitNode(RwiNode rwiNode) {
		rwiElements.add(rwiNode);
		return null;
	}

	public Object visitMember(RwiMember rwiMember) {
		rwiElements.add(rwiMember);
		return null;
	}

	public Object visitLink(RwiLink rwiLink) {
		rwiElements.add(rwiLink);
		return null;
	}

    /**
     * @supplierCardinality 1
     * @link aggregation 
     */
    private List rwiElements;
}


