package com.togethersoft.modules.bettersoftwarefaster.rwisupport;

import com.togethersoft.openapi.ide.*;
import com.togethersoft.openapi.ide.message.*;

import com.togethersoft.openapi.rwi.*;
import java.util.*;

/**
 * Collect all elements in the model, using a subclass design.
 * Acts as own filter and visitor.  Just print out the number of elements.
 */
public class DemoSubclassModule extends RwiVisitorSupport implements IdeScript {

    public DemoSubclassModule() {
        super("DemoSubClass");
    }

	public void run(IdeContext ideContext) {
        getMessagePage().printMessage("Started.");

    	if (!isActiveProject())
        	return;

		getRwiVisitorDispatcher().visitAndDispatch();

		getMessagePage().printMessage("Number of elements: " + getCollectedRwiElements().size() );
        getMessagePage().setVisible(true);
        getMessagePage().printMessage("Finished.");
	}

	////////////////////////////////////////////////////////////////////

	public Object visitPackage(RwiPackage rwiPackage) {
		rwiElements.add(rwiPackage);
		return null;
	}

    public boolean visitDiagrams(){ return true; }
	public Object visitDiagram(RwiDiagram rwiDiagram) {
		rwiElements.add(rwiDiagram);
		return null;
	}

    public boolean visitNodes(){ return true; }
	public Object visitNode(RwiNode rwiNode) {
		rwiElements.add(rwiNode);
		return null;
	}

    public boolean visitMembers(){ return true; }
	public Object visitMember(RwiMember rwiMember) {
		rwiElements.add(rwiMember);
		return null;
	}

    public boolean visitLinks(){ return true; }
	public Object visitLink(RwiLink rwiLink) {
		rwiElements.add(rwiLink);
		return null;
	}

	////////////////////////////////////////////////////////////////////

	public List getCollectedRwiElements() {
		return Collections.unmodifiableList(rwiElements);
	}
    /**
    * @supplierRole collectedRwiElements
    * @link aggregationByValue
    * @supplierCardinality 1
    */
	private List rwiElements = new LinkedList();
}
