package com.togethersoft.modules.qa.audit.HUNGARIAN;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import com.togethersoft.openapi.sci.*;
import com.togethersoft.modules.qa.utils.*;

class TypeChecker {

    private final static int PREFERRED_HEIGHT = 20;

	private String typeName;

	/**
	 * @supplierRole row 
	 */
	private JPanel panel;
	private JTextField prefixTF; // encapsulates 'prefix' property
    private JCheckBox checkBox;  // encapsulates 'enabled' property

	TypeChecker(String typeName) {
		this.typeName = typeName;

	    checkBox = new JCheckBox(typeName, true);
		checkBox.setPreferredSize(new Dimension(60, PREFERRED_HEIGHT));
	    checkBox.addItemListener(
	    new ItemListener() {
	    	public void itemStateChanged(ItemEvent ev) {
	       		TypeChecker.this.prefixTF.setEnabled((ev.getStateChange() == ItemEvent.SELECTED));
	    	}
	    });

		this.panel = new JPanel(new FlowLayout(FlowLayout.LEFT, 0, 0));;
	    this.panel.add(checkBox);

	    JLabel prefixLB = new JLabel("prefix: ");
	    this.panel.add(prefixLB);

	    prefixTF = new JTextField("", 3);
		prefixTF.setPreferredSize(
            new Dimension( (int)prefixTF.getPreferredSize().getWidth(), PREFERRED_HEIGHT) );
	    this.panel.add(prefixTF);
	}

	boolean isOk(SciVariable var) {
	    if (!isEnabled())
	        return true;
		if (!var.getType().getText().equals(getTypeName()))
	        return true;
	    if (var.getName().startsWith(getPrefix()))
	        return true;
	    return false;
	}

	String getTypeName() { return typeName; }

	public boolean isEnabled(){
		return checkBox.isSelected();
	}
	public void setEnabled(boolean enabled){
        if (checkBox.isSelected() != enabled) {
            checkBox.doClick(); // emulate click - fires listeners
        }
	}

    public String getPrefix() {
	    return this.prefixTF.getText();
    }
    public void setPrefix(String prefix) {
	    this.prefixTF.setText(prefix);
    }
	Component toComponent() {
		return this.panel;
	}
}
