package com.togethersoft.modules.bettersoftwarefaster.rwisupport;

import com.togethersoft.openapi.ide.*;
import com.togethersoft.openapi.ide.message.*;
import com.togethersoft.openapi.rwi.*;


import java.util.*;

/**
 * Because RWI modules are often involved in validating the repository, the RWI Support package has built in support for wrapping up validation exceptions and displaying them directory.
 * <p>This class represents such a validation exception.  It can be printed onto the RwiMessagePage.
 * @see RwiMessagePage 
 */
public class ValidationException extends Exception {
    public ValidationException(String message, RwiElement rwiElement) {
        super(message);
        this.rwiElement = rwiElement;
    }

    public RwiElement getRwiElement() { return this.rwiElement; }

    final private RwiElement rwiElement;
}


