package com.togethersoft.modules.bettersoftwarefaster.rwisupport;

import java.util.*;

/**
 * As a convenience, allows a collection of validation exceptions to be assembled; they can then be printed to the RwiMessagePage as a single unit.
 * @see RwiMessagePage 
 */
public class ValidationExceptionCollector {
	/**
	 * @link aggregation
	 *   @associates <{ValidationException}>
	 * @clientCardinality 1
	 * @supplierCardinality 0..*
	 * @supplierRole validationExceptions
	 * @constraint {ordered}
	 */
	private List validationExceptions = new ArrayList();

    public void add(ValidationException ex) {
        validationExceptions.add(ex);
    }

    public Iterator iterator() {
        return Collections.unmodifiableList(validationExceptions).iterator();
    }

    public void clear() {
        validationExceptions.clear();
    }

    public int size() {
        return validationExceptions.size();
    }
}


