package com.togethersoft.modules.inspector.bettersoftwarefaster.inspectorsupport;

import java.util.*;
import com.togethersoft.openapi.ide.inspector.*;
import com.togethersoft.openapi.ide.window.IdeSelectorDialogType;
import com.togethersoft.openapi.ide.*;
import com.togethersoft.openapi.util.*;


public class DemoInspector extends IdeInspectorBuilderAdapter {
    protected void buildClassDiagramInspector() { 
		addDemoProperties();
	}
    protected void buildClassInspector() {
		addDemoProperties();
    }
    protected void buildInterfaceInspector() {
		addDemoProperties();
    }
    protected void buildAttributeInspector() {
		addDemoProperties();
    }
    protected void buildLinkInspector() {
		addDemoProperties();
	}
    protected void buildOperationInspector() {
		addDemoProperties();
    }

	private void addDemoProperties() {

		// string
		addStringProperty(
			"Demo", "stringProperty", "String property");

		// boolean
        addBooleanProperty(
			"Demo", "booleanProperty", "Boolean property?");

		// int
		addIntegerProperty(
			"Demo", "integerProperty", "Integer property");

		// float
		addFloatProperty(
			"Demo", "floatProperty", "Float property");

		// choice (must select from the choices)
		addChoiceProperty(
			"Demo", "choiceProperty", "Choice property",
            new String[] { "choice1", "choice2", "choice3" } );

		// combo box (can ignore the choices)
		addComboBoxProperty(
			"Demo", "comboBoxProperty", "ComboBox property",
            new String[] { "comboBoxValue1", "comboBoxValue2", "comboBoxValue3" } );

		// extended strings
        addExtendedStringProperty(
			"Demo", "extendedStringProperty", "Extended string property");

		// class field
        addClassProperty(
			"Demo", "classProperty", "Class property", IdeSelectorDialogType.CLASSES_AND_INTERFACES);

		// multiple strings
        addMultipleStringProperty(
			"Demo", "multiStringProperty", "Multiple string property");

		// URL
        addURLProperty(
			"Demo", "urlProperty", "URL property");

		// inversed boolean
		addInversedBooleanProperty(
			"Demo", "inversedBooleanProperty", "Inversed boolean property");

		// color
		addColorProperty(
			"Demo", "colorProperty", "Color property");

		// some conditionals (not all shown)
		addBooleanProperty(
			"Demo", "showConditionalProperty", "Show conditional string?");
        Condition ifshowConditionalProperty =
			new Condition() {
				public boolean execute(
                    IdeContext context
                    ) {
					return
					RwiElementsUtil.checkProperty(
					context, "showConditionalProperty", true);
				}
			};
		addStringProperty(
			"Demo", "conditionalStringProperty", "Conditional string property",
			ifshowConditionalProperty);

/*
		///////////////////////////////////////////////////////////
		// adding properties to the pre-defined Properties table
        // is unpredictable; it works for some element types but
        // not for others
		///////////////////////////////////////////////////////////

		// boolean
        addBooleanProperty(
			"Properties", "demoBooleanProperty", "Demo boolean property?");

		// string
		addStringProperty(
			"Properties", "demoStringProperty", "Demo string property" );
*/
	}
}


